//---------------------------------------------------------
//  RG Basic Tools Collection
//  Copyright © 2004 -2009 Ronald D. Grindle
//
//This file is part of the Rslt services.
//
//Rslt services is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//Rslt services is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Rslt services.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------

package com.qanavigation.DBacc;

import java.sql.SQLException;

import com.qanavigation.Basics.IRslt;
import com.qanavigation.Basics.Rslt;


/**
 * @author RDG
 *
 */
public class SQLRslt extends Rslt implements ISQLRslt {

	protected int m_lastErrCode;
	
	//--------------------------------------------
	public void resetRslt() {
			
		m_lastErrCode = 0;

		super.resetRslt();
	}
		
	// --------------------------------------------
	public void setRsltByExcp( SQLException p_Excp ) {
	
		SQLException nxtExcp;
		
		while( null != (nxtExcp = p_Excp.getNextException()) ) {
			
			setRsltByExcp( nxtExcp );
		}
		
		addRsltAddInfo( "SQL state: " + p_Excp.getSQLState() );
		
		addRsltAddInfo( "Error code: " + p_Excp.getErrorCode() );
		
		m_lastErrCode = p_Excp.getErrorCode();
		
		super.setRsltByExcp( p_Excp );
	}
	
	/**
	 * 
	 * @param p_SQLRslt
	 */
	public boolean checkRslt( ISQLRslt p_SQLRslt ) {
		
		boolean isOK;
		
		isOK = super.checkRslt( p_SQLRslt );
		
		m_lastErrCode = p_SQLRslt.getLastErrorCode();
		
		return isOK;
	}
	
	/**
	 * 
	 * @return m_lastErrCode
	 */
	public int getLastErrorCode() {
		
		return m_lastErrCode;
	}
	
	// --------------------------------------------
	protected void init() {
		
		m_lastErrCode = 0;
	}
	
	/**
	 * 
	 */
	public SQLRslt() {
		super();
		init();
	}
	
	/**
	 * 
	 * @param p_isOK
	 */
	public SQLRslt( boolean p_isOK ) {
		
		super( p_isOK );
		init();
	}

	/**
	 * @param p_aRes
	 */
	public SQLRslt(IRslt p_aRes) { 
		super(p_aRes);
		init();
	}

	/**
	 * @param p_aRes
	 */
	public SQLRslt(Rslt p_aRes) {
		super(p_aRes);
		init();
	}

	/**
	 * @param p_aResStat
	 */
	/*
	public SQLRslt(int p_aResStat) {
		
		super(p_aResStat);
		init();
	}*/

	/**
	 * @param p_aResStat
	 * @param p_LastMsg
	 */
	/*
	public SQLRslt(int p_aResStat, String p_LastMsg) {
		super(p_aResStat, p_LastMsg);
		init();
	}*/

}
